/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

function __values(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
}

function spaceTrim(str /* TODO: , char: RegExp = /\s/*/) {
    var e_1, _a;
    // ✂️ Trimming from top and bottom
    str = spaceTrimFromTop(str);
    str = spaceTrimFromTop(str.split('\n').reverse().join('\n')).split('\n').reverse().join('\n');
    // ✂️ Trimming from left and right
    var minStartWhitespaceLength = null;
    var maxContentLength = 0;
    var lines = str.split('\n');
    try {
        for (var lines_1 = __values(lines), lines_1_1 = lines_1.next(); !lines_1_1.done; lines_1_1 = lines_1.next()) {
            var line = lines_1_1.value;
            var _b = line.match(/^(?<startWhitespace>\s*)(?<content>.*?)(\s*)$/).groups, startWhitespace = _b.startWhitespace, content = _b.content;
            minStartWhitespaceLength = Math.min(minStartWhitespaceLength || 99999999999999, startWhitespace.length);
            maxContentLength = Math.max(maxContentLength, content.length);
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (lines_1_1 && !lines_1_1.done && (_a = lines_1.return)) _a.call(lines_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    str = lines
        .map(function (line) { return line.substring(minStartWhitespaceLength, minStartWhitespaceLength + maxContentLength); })
        .join('\n');
    return str;
}
function spaceTrimFromTop(str) {
    var e_2, _a;
    var linesWithContent = [];
    var contentStarted = false;
    var lines = str.split('\n');
    try {
        for (var lines_2 = __values(lines), lines_2_1 = lines_2.next(); !lines_2_1.done; lines_2_1 = lines_2.next()) {
            var line = lines_2_1.value;
            if (line.trim() !== '') {
                contentStarted = true;
            }
            if (contentStarted) {
                linesWithContent.push(line);
            }
        }
    }
    catch (e_2_1) { e_2 = { error: e_2_1 }; }
    finally {
        try {
            if (lines_2_1 && !lines_2_1.done && (_a = lines_2.return)) _a.call(lines_2);
        }
        finally { if (e_2) throw e_2.error; }
    }
    return linesWithContent.join('\n');
}

export { spaceTrim as default, spaceTrim, spaceTrimFromTop };
//# sourceMappingURL=spaceTrim.js.map
